## mingw-w64-kwidgetsaddons-6.1.0-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

set(KF_VERSION "6.1.0") # handled by release scripts
project(KWidgetsAddons VERSION ${KF_VERSION})

include(FeatureSummary)
find_package(ECM 6.1.0  NO_MODULE)
set_package_properties(ECM PROPERTIES TYPE REQUIRED DESCRIPTION "Extra CMake Modules." URL "https://commits.kde.org/extra-cmake-modules")
feature_summary(WHAT REQUIRED_PACKAGES_NOT_FOUND FATAL_ON_MISSING_REQUIRED_PACKAGES)


set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings)

include(KDEGitCommitHooks)
include(ECMDeprecationSettings)

set(REQUIRED_QT_VERSION 6.5.0)
find_package(Qt6 ${REQUIRED_QT_VERSION} CONFIG REQUIRED Widgets)


include(ECMGenerateExportHeader)
include(CMakePackageConfigHelpers)
include(ECMSetupVersion)
include(ECMGenerateHeaders)
include(ECMAddQch)
include(ECMPoQmTools)
include(ECMQtDeclareLoggingCategory)
include(CMakeDependentOption)

set(kwidgetsaddons_version_header "${CMAKE_CURRENT_BINARY_DIR}/src/kwidgetsaddons_version.h")
ecm_setup_version(PROJECT VARIABLE_PREFIX KWIDGETSADDONS
                        VERSION_HEADER "${kwidgetsaddons_version_header}"
                        PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KF6WidgetsAddonsConfigVersion.cmake"
                        SOVERSION 6)

set(EXCLUDE_DEPRECATED_BEFORE_AND_AT 0 CACHE STRING "Control the range of deprecated API excluded from the build [default=0].")

option(BUILD_QCH "Build API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)" OFF)
add_feature_info(QCH ${BUILD_QCH} "API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)")

cmake_dependent_option(BUILD_DESIGNERPLUGIN "Build plugin for Qt Designer" ON "NOT CMAKE_CROSSCOMPILING" OFF)
add_feature_info(DESIGNERPLUGIN ${BUILD_DESIGNERPLUGIN} "Build plugin for Qt Designer")


ecm_install_po_files_as_qm(poqm)

configure_file(test-config.h.in ${CMAKE_CURRENT_BINARY_DIR}/test-config.h)

ecm_set_disabled_deprecation_versions(
    QT 6.5
)

add_subdirectory(src)
if (BUILD_TESTING)
    add_subdirectory(autotests)
    add_subdirectory(tests)
    add_subdirectory(examples)
endif()

# create a Config.cmake and a ConfigVersion.cmake file and install them
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KF6WidgetsAddons")

if (BUILD_QCH)
    ecm_install_qch_export(
        TARGETS KF6WidgetsAddons_QCH
        FILE KF6WidgetsAddonsQchTargets.cmake
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        COMPONENT Devel
    )
    set(PACKAGE_INCLUDE_QCHTARGETS "include(\"\${CMAKE_CURRENT_LIST_DIR}/KF6WidgetsAddonsQchTargets.cmake\")")
endif()

configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/KF6WidgetsAddonsConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/KF6WidgetsAddonsConfig.cmake"
                              INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
                              )

install(FILES  "${CMAKE_CURRENT_BINARY_DIR}/KF6WidgetsAddonsConfig.cmake"
               "${CMAKE_CURRENT_BINARY_DIR}/KF6WidgetsAddonsConfigVersion.cmake"
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        COMPONENT Devel )

install(EXPORT KF6WidgetsAddonsTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" FILE KF6WidgetsAddonsTargets.cmake NAMESPACE KF6:: )

install(FILES
  ${kwidgetsaddons_version_header}
  DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/KWidgetsAddons COMPONENT Devel
)

include(ECMFeatureSummary)
ecm_feature_summary(WHAT ALL   FATAL_ON_MISSING_REQUIRED_PACKAGES)

kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

=== src/designer/CMakeLists.txt ===
include(ECMAddQtDesignerPlugin)

ecm_qtdesignerplugin_widget(KActionSelector
    TOOLTIP "A widget for selecting and arranging actions/objects"
    GROUP "Views (KF6)"
)
ecm_qtdesignerplugin_widget(KAnimatedButton
    TOOLTIP "An extended version of QToolButton which can display an animated icon."
    GROUP "Display (KF6)"
)
ecm_qtdesignerplugin_widget(KBusyIndicatorWidget
    TOOLTIP "Busy Indicator (KF6)"
    GROUP "Display (KF6)"
)
ecm_qtdesignerplugin_widget(KCapacityBar
    TOOLTIP "Capacity Bar (KF6)"
    CONSTRUCTOR_ARGS_CODE "(KCapacityBar::DrawTextOutline, parent)"
    GROUP "Display (KF6)"
)
ecm_qtdesignerplugin_widget(KCharSelect
    TOOLTIP "Character Selection Widget (KF6)"
    WHATSTHIS "A widget that allows selecting a character out of a table"
    GROUP "Graphics (KF6)"
)
ecm_qtdesignerplugin_widget(KCollapsibleGroupBox
    TOOLTIP "A group box which can be expanded and collapsed"
    GROUP "Display (KF6)"
    CONTAINER
)
ecm_qtdesignerplugin_widget(KColorButton
    TOOLTIP "Color Chooser Button (KF6)"
    WHATSTHIS "A button that allows selecting a color"
    GROUP "Graphics (KF6)"
)
ecm_qtdesignerplugin_widget(KColorCombo
    TOOLTIP "Color Combo Box (KF6)"
    GROUP "Graphics (KF6)"
)
ecm_qtdesignerplugin_widget(KDatePicker
    TOOLTIP "A date selection widget (KF6)"
    WHATSTHIS "Provides a widget for calendar date input"
    GROUP "Date/Time (KF6)"
)
ecm_qtdesignerplugin_widget(KDateComboBox
    TOOLTIP "This widget can be used to display or edit the date. (KF6)"
    GROUP "Date/Time (KF6)"
)
ecm_qtdesignerplugin_widget(KDateTimeEdit
    TOOLTIP "This widget can be used to display or edit the date and time. (KF6)"
    GROUP "Date/Time (KF6)"
)
ecm_qtdesignerplugin_widget(KEditListWidget
    TOOLTIP "Fullfeatured edit box with buttons (KF6)"
    GROUP "Views (KF6)"
)
ecm_qtdesignerplugin_widget(KFontChooser
    ICON pics/kfontcombo.png
    TOOLTIP "Font Chooser (KF6)"
    WHATSTHIS "A font type, size and style selection widget complete with preview"
    GROUP "Input (KF6)"
)
ecm_qtdesignerplugin_widget(KFontRequester
    TOOLTIP "Font Requester (KF6)"
    WHATSTHIS "A compact font selection and preview widget"
    GROUP "Input (KF6)"
)
ecm_qtdesignerplugin_widget(KGradientSelector
    INCLUDE_FILE kselector.h
    TOOLTIP "Gradient Color Selector (KF6)"
    GROUP "Input (KF6)"
)
ecm_qtdesignerplugin_widget(KLed
    TOOLTIP "LED Widget (KF6)"
    WHATSTHIS "A widget showing a light emitter diode"
    GROUP "Display (KF6)"
)
ecm_qtdesignerplugin_widget(KMessageWidget
    TOOLTIP "Display an information or error message in an animated bubble."
    GROUP "Display (KF6)"
)
ecm_qtdesignerplugin_widget(KMimeTypeChooser
    TOOLTIP "Provides a checkable list of all available MIME types."
    CONSTRUCTOR_ARGS_CODE "(QString(), QStringList(), QString(), QStringList(), KMimeTypeChooser::Comments | KMimeTypeChooser::Patterns, parent)"
    GROUP "Input (KF6)"
)
ecm_qtdesignerplugin_widget(KMultiTabBar
    TOOLTIP "Multi Tab Bar Widget (KF6)"
    WHATSTHIS "A Widget for horizontal and vertical tabs."
    CONSTRUCTOR_ARGS_CODE "(KMultiTabBar::Left, parent)"
    GROUP "Display (KF6)"
)
ecm_qtdesignerplugin_widget(KNewPasswordWidget
    TOOLTIP "A password input widget"
    WHATSTHIS "This widget allows the user to enter a new password."
    GROUP "Input (KF6)"
)
ecm_qtdesignerplugin_widget(KPageView
    TOOLTIP "Paged View (KF6)"
    WHATSTHIS "A base class which can handle multiple pages."
    GROUP "Views (KF6)"
)
ecm_qtdesignerplugin_widget(KPageWidget
    TOOLTIP "Paged Widget (KF6)"
    WHATSTHIS "Page widget with many layouts (faces)."
    GROUP "Views (KF6)"
)
ecm_qtdesignerplugin_widget(KPasswordLineEdit
    TOOLTIP "A Password LineEdit (KF6)"
    WHATSTHIS "A Custom LineEdit which allows to show password"
    GROUP "Input (KF6)"
)
ecm_qtdesignerplugin_widget(KPixmapRegionSelectorWidget
    TOOLTIP "Pixmap Region Selector (KF6)"
    GROUP "Graphics (KF6)"
)
ecm_qtdesignerplugin_widget(KPixmapSequenceWidget
    TOOLTIP "Pixmap Sequence Widget (KF6)"
    WHATSTHIS "A simple widget showing a fixed size pixmap sequence."
    GROUP "Display (KF6)"
)
ecm_qtdesignerplugin_widget(KPopupFrame
    TOOLTIP "Frame with Popup Menu Behavior (KF6)"
    CONTAINER
    GROUP "Display (KF6)"
)
ecm_qtdesignerplugin_widget(KRatingWidget
    TOOLTIP "Rating value display (KF6)"
    WHATSTHIS "Displays a rating as a range of stars or other arbitrary pixmaps."
    GROUP "Display (KF6)"
)
ecm_qtdesignerplugin_widget(KRuler
    TOOLTIP "Measuring Ruler Widget (KF6)"
    WHATSTHIS "A measuring ruler widget as seen in KWord for page widths and heights"
    GROUP "Display (KF6)"
)
ecm_qtdesignerplugin_widget(KSeparator
    TOOLTIP "Standard horizontal or vertical separator."
    GROUP "Display (KF6)"
)
ecm_qtdesignerplugin_widget(KSqueezedTextLabel
    TOOLTIP "A QLabel that squeezes its text (KF6)"
    WHATSTHIS "If the text is too long to fit into the label it is divided into remaining left and right parts which are separated by three dots"
    CONSTRUCTOR_ARGS_CODE "(QStringLiteral(\"KSqueezedTextLabel\"), parent)"
    GROUP "Display (KF6)"
)
ecm_qtdesignerplugin_widget(KTimeComboBox
    TOOLTIP "This widget can be used to display or edit the time. (KF6)"
    GROUP "Date/Time (KF6)"
)
ecm_qtdesignerplugin_widget(KTitleWidget
    TOOLTIP "Title box with label and icon"
    WHATSTHIS "A styled frame to be used in title positions in dialogs and other widgets"
    GROUP "Display (KF6)"
)
ecm_qtdesignerplugin_widget(KUrlLabel
    TOOLTIP "URL Label (KF6)"
    CONSTRUCTOR_ARGS_CODE "(QStringLiteral(\"KUrlLabel\"), QString(), parent)"
    GROUP "Display (KF6)"
)

ecm_add_qtdesignerplugin(kwidgetsaddonswidgets
    NAME KWidgetsAddonsWidgets
    OUTPUT_NAME kwidgetsaddons6widgets
    WIDGETS
        KActionSelector
        KAnimatedButton
        KBusyIndicatorWidget
        KCapacityBar
        KCharSelect
        KCollapsibleGroupBox
        KColorButton
        KColorCombo
        KDateComboBox
        KDatePicker
        KDateTimeEdit
        KEditListWidget
        KFontChooser
        KFontRequester
        KGradientSelector
        KLed
        KMessageWidget
        KMimeTypeChooser
        KMultiTabBar
        KNewPasswordWidget
        KPageView
        KPageWidget
        KPasswordLineEdit
        KPixmapRegionSelectorWidget
        KPixmapSequenceWidget
        KPopupFrame
        KRatingWidget
        KRuler
        KSeparator
        KSqueezedTextLabel
        KTimeComboBox
        KTitleWidget
        KUrlLabel
    LINK_LIBRARIES
        KF6::WidgetsAddons
    INSTALL_DESTINATION "${KDE_INSTALL_QTPLUGINDIR}/designer"
    COMPONENT Devel
)

=== PKGBUILD ===
# Maintainer: Biswapriyo Nath <nathbappai@gmail.com>

source "$(dirname ${BASH_SOURCE[0]})"/../mingw-w64-PKGBUILD-common/kde-frameworks
_realname=kwidgetsaddons
pkgbase="mingw-w64-${_realname}"
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=6.1.0
pkgrel=1
pkgdesc="Addons to QtWidgets (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
msys2_references=(
  'archlinux: kwidgetsaddons'
)
msys2_repository_url='https://invent.kde.org/frameworks/kwidgetsaddons/'
url='https://community.kde.org/Frameworks/'
license=('spdx:LGPL-2.0-or-later')
depends=(
  "${MINGW_PACKAGE_PREFIX}-qt6-base"
)
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cc"
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-extra-cmake-modules"
  "${MINGW_PACKAGE_PREFIX}-ninja"
  "${MINGW_PACKAGE_PREFIX}-qt6-tools"
)
groups=("${MINGW_PACKAGE_PREFIX}-kf6")
source=("https://download.kde.org/stable/frameworks/${pkgver%.*}/${_realname}-${pkgver}.tar.xz"{,.sig})
sha256sums=('81225d7ec2d6ea738ded55fe41978deb639c3f77a2daad0eb2e5423aa046e4ce'
            'SKIP')
validpgpkeys=('E0A3EB202F8E57528E13E72FD7574483BB57B18D') # Jonathan Esk-Riddell <jr@jriddell.org>

build() {
  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  _kde_build_env
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_KDE_INSTALL_DIRS[@]}" \
      -DBUILD_QCH=OFF \
      -DBUILD_TESTING=OFF \
      "${_extra_config[@]}" \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  "${MINGW_PREFIX}"/bin/cmake.exe --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install "build-${MSYSTEM}"
}
